#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

#include "StringBuffer.h"

StringBuffer::StringBuffer()
{
  _b=NULL;
  _allocated=0;
  _size=0;
  
  grow();
}

StringBuffer::~StringBuffer()
{
  if (_b!=NULL)
    free(_b);
}

void StringBuffer::grow()
{
  _allocated=_allocated*2;
  if (_allocated<8)
    _allocated=8;

  _b=(char*) realloc(_b,_allocated);
  _b[_size]=0;
}

char *StringBuffer::getBuf()
{
  return _b;
}

int StringBuffer::append(char c)
{
  while (_allocated<(_size+1))
    grow();

  _b[_size]=c;
  _size++;
  _b[_size]=0;

  return _size;
}

int StringBuffer::append(const char *s)
{
  int newsize=strlen(s)+_size;

  while (_allocated<newsize)
    grow();

  strcpy(&_b[_size],s);
  _size=newsize;

  _b[_size]=0;
  return _size;
}

int StringBuffer::appendf(const char *format, ...)
{
  va_list ap;

  char *buf=NULL;

  va_start(ap,format);
  int len=vsnprintf(NULL,0,format,ap);
  va_end(ap);

  buf=(char*) malloc(len+1);
  va_start(ap,format);
  vsnprintf(buf,len+1,format,ap);
  va_end(ap);

  append(buf);
  free(buf);
  
  _b[_size]=0;
  return _size;
}

