#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "Table.h"
#include "StringBuffer.h"

void appendURLEncoded(StringBuffer *sb, char *s);

char *tabletoform(Table *t)
{
  StringBuffer *sb=new StringBuffer();

  int size=t->getSize();
  for (int i=0;i<size;i++)
    {
      char *k=t->getKey(i);
      char *v=t->getValue(i);

      appendURLEncoded(sb,k);
      sb->append("=");
      appendURLEncoded(sb,v);

      if ((i+1)<size)
	sb->append("&");
    }

  char *buf=strdup(sb->getBuf());
  delete sb;

  return buf;
}

/** append the url encoded version of s to sb */
void appendURLEncoded(StringBuffer *sb, char *s)
{
  int len=strlen(s);

  for (int i=0;i<len;i++)
    {
      if (isalnum(s[i]))
	sb->append(s[i]);
      else
	sb->appendf("%%%2x",s[i]);
    }
}
